(jQuery)(function () {
	
	fix_metro_homepage();
	fix_portfolio();
	fix_slideshow_portfolio();
	fix_portfolio_reponsive();
	fix_main_menu();
	fix_scroll_page();
	fix_home_menu();
	fix_isotope();
	
	function fix_main_menu() {
		var menu_item = (jQuery)('#main-menu li a');
		var responsive = (jQuery)('.responsive-menu-button');
		var navigation = (jQuery)((jQuery)('#main-menu .container').children()[1]);
		
		menu_item.click(function () {
			var self = (jQuery)(this);
			
			var tmpArr = self.attr('href').split('/');
			var strSection = tmpArr[tmpArr.length-1];
			var positionY = (jQuery)(strSection).offset().top;
			(jQuery)('html, body').animate({
				scrollTop: positionY
			}, 500);
		});
		
		responsive.click(function () {
			navigation.toggle();
		});
		
		(jQuery)(window).resize(function(){
			if((jQuery)(this).width() > 991){
				navigation.show();
			} else {
				navigation.hide();
			}
		});
	}
	
	function fix_scroll_page() {
		(jQuery)('.front #main-menu li a').first().addClass('current');
		

		var menu_item = (jQuery)('.front #main-menu li a');
		
		(jQuery)(window).scroll(function () {



			clearTimeout((jQuery).data( this, "scrollCheck" ));

			(jQuery).data( this, "scrollCheck", setTimeout(function() {


				var doc = document.documentElement;
				var top = (window.pageYOffset || doc.scrollTop)  - (doc.clientTop || 0);
				var height = (jQuery)(window).height() / 2;
				
				menu_item.removeClass('current');
				menu_item.each(function (i, e) {
					var self = (jQuery)(this);
					
					var menu = self.attr('href');
					var menuArr = menu.split('/');
					var menuSection = menuArr[menuArr.length-1];
					if(menuSection.substring('0','2')== 'ar')
					{
						var strSection = menuSection.substring('2');
						/*var tmpArr = self.attr('href').split('/');
						var strSection = tmpArr[tmpArr.length-1];*/
						var section = (jQuery)(strSection);
						var top = section.offset().top - (jQuery)(window).scrollTop();
						var sectionHeight = section.parent().height(); 
						var bottom = top + sectionHeight;
						if (bottom >= height) {
							self.addClass('current');
							return false;
						}
					}
					else
					{
						/*var tmpArr = menu.split('/');
						var strSection = tmpArr[tmpArr.length-1];*/
						var section = (jQuery)(menuSection);
						var top = section.offset().top - (jQuery)(window).scrollTop();
						var sectionHeight = section.parent().height(); 
						var bottom = top + sectionHeight;
						if (bottom >= height) {
							self.addClass('current');
							return false;
						}
					}


				});
			}));
		});
		
	}
	
	function fix_home_menu() {
		(jQuery)('.metro-block .metro-link .metro-homepage a').click(function () {
			var self = (jQuery)(this);
			
			var tmpArr = self.attr('href').split('/');
			var strSection = tmpArr[tmpArr.length-1];
			var positionY = (jQuery)(strSection).offset().top;
			(jQuery)('html, body').animate({
				scrollTop: positionY
			}, 500);
		});
	}
	
	function fix_portfolio() {		
		var listClasses = new Array();
		(jQuery)('.portfolio-isotope .view-header .views-row a').each(function (i, e) {
			if (i > 0) {
				var self = (jQuery)(this);
				var classes = self.attr('class');
				//var arrClasses = classes.split(' ');
				if (classes.indexOf('current')) {
					classes = classes.replace(' current', '');
				}

				var keyClass = classes;
				var find = ' ';
				var re = new RegExp(find, 'g');
				classes = classes.replace(re, '');
				listClasses[keyClass] = classes;
				self.attr('class', classes);
			}
		});
		(jQuery)('.portfolio-isotope .view-content-body .views-row').each(function (i, e) {
			var self = (jQuery)(this);
			var classes = self.attr('class');
			if (classes.indexOf(' views-row')) {
				classes = classes.replace(' views-row', '');
			}
			
			//var find;
			//var re;
			for (var k in listClasses) {
				if (classes.indexOf(k)) {
					var tmpKey = k.split('-')[0];
					//find = k;
					//re = new RegExp(find, 'g');
					classes = classes.replace(tmpKey, listClasses[k].split('-')[0]);	
					//debugger;
				}
			}
			classes += ' views-row';
			self.attr('class', classes);
		});
		(jQuery)('.portfolio-isotope .view-content-body .views-row').each(function(i, e) {
			var self = (jQuery)(this);
			
			var image = getWholeElementHTML(self.find('.views-field-field-image'));
			var title = getWholeElementHTML(self.find('.views-field-title'));
			var body = getWholeElementHTML(self.find('.views-field-body'));
			var node = getWholeElementHTML(self.find('.views-field-view-node'));
			
			var outerHMTL = (jQuery)('<div class="view-field-nothing">').append(title).append(body).append(node);
			outerHMTL = getWholeElementHTML(outerHMTL);
			outerHMTL = (jQuery)('<div class="views-field">').append(image + outerHMTL);
			outerHMTL = getWholeElementHTML(outerHMTL);
			
			self.html(outerHMTL);
		});
	}
	
	function fix_portfolio_reponsive() {
		var content = jQuery('.portfolio-isotope .view-content-body');
        var header = jQuery('.portfolio-isotope .view-header .view-content');
        content.isotope({
            itemSelector: '.views-row',
            layoutMode: 'fitRows'
        });
        header.find('.All-filter').addClass('current');
		var select = (jQuery)('<select class="portfolio-select-list">');
			header.find('a').each(function (i, e) {
			var self = (jQuery)(this);
			var classNames = self.attr('class');
			var text = self.text();
			var option = '<option class="' + classNames + '">' + text + '</option>';
			select.append(option);
		});

		header.append(getWholeElementHTML(select));
		(jQuery)(document).find('.portfolio-isotope .view-header select').on('change', function () {
			var option = (jQuery)(this).find('option:selected');
            var classNames = option.attr('class');
            var filter = classNames.split('-')[0];
            header.find('option').removeClass('current');
            option.addClass('current');
            if (filter == 'All') {
                content.isotope({filter : '*'});
            }
            else {
                content.isotope({filter : '.' + filter});
            }
            
            e.preventDefault();
            return false;
		});
	}
	
	function fix_slideshow_portfolio() {
		fix_slider_html();
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider({
			animation: "slide",
		});
		onDrag();
	}
	
	function fix_metro_homepage() {
		(jQuery)('.metro-block .view-content .metro-link').each(function(i, e) {
			var self = (jQuery)(this);
			var title = self.find('.metro-title a');
			var icon = self.find('.views-field-field-icon');
			var color = self.find('.views-field-field-color');
			var outerHMTL;
			var innerHTML;

			innerHTML = (jQuery)('<div class="metro-info">').html(getWholeElementHTML(title.parent()));
			innerHTML = getWholeElementHTML(innerHTML);
			outerHMTL = (jQuery)('<div class="metro-homepage" style="background-color: ' + color.text() + '">').append(innerHTML);
			self.html(outerHMTL);
		});
		
		(jQuery)('.metro-block .view-content .metro-content').each(function(i, e) {
			var self = (jQuery)(this);
			var image = getWholeElementHTML(self.find('img'));
			var title = self.find('.metro-title');
			var body = getWholeElementHTML(self.find('.views-field-body'));
			var link = self.find('.metro-title a').attr('href');
			var outerHMTL;
			var innerHTML;
			
			innerHTML = (jQuery)('<div class="metro-info">').append(title).append(body);
			innerHTML = getWholeElementHTML(innerHTML);
			//outerHMTL = (jQuery)('<div class="metro-homepage">').append(image).append(innerHTML);
			innerHTML = (jQuery)('<a href="' + link + '">').append(image).append(innerHTML);
			outerHMTL = (jQuery)('<div class="metro-homepage">').append(innerHTML);
			self.html(outerHMTL);
		});
	}
	
	function fix_isotope() {

		var parent = (jQuery)('.portfolio-isotope .view-content-body');
		if (parent.offset() == undefined) return;
		var parentOffsetTop = parent.offset().top;
		var children = (jQuery)('.portfolio-isotope .view-content-body').children();
		var row = 0;
		var curOffsetTop = 0;
		var nodeHeight = children.first().height();
		var marginBottom = 8; // 8px
		children.each(function (i, e) {
			var self = (jQuery)(this);
			var offset = self.offset().top - parentOffsetTop;
			
			if (curOffsetTop < offset) {
				curOffsetTop = offset;
				row++;
			}
			
			self.css({ 'top' : row * (nodeHeight + marginBottom) + 'px' });
		});
		parent.css({ 'height' : (row + 1) * (nodeHeight + marginBottom) + 'px' });
	}
	
	
	
	function fix_slider_html() {
		var parent = (jQuery)('#block-onepage-content .owl-carousel-portfolio');
		var sliderContainer = (jQuery)(parent.children()[0]);
		var slider = (jQuery)('<ul class="slides"></ul>');
		sliderContainer.children().each(function (i, e) {
			var self = (jQuery)(this);
			var image = self.find('img').parent();
			var newElement = '<li>' + image.html() + '</li>';
			
			(jQuery)(slider).append(newElement);
		});
		parent.empty();
		parent.append(slider);
		
		/*
		<ul class="slides">
            <li>
  	    	    <img src="images/kitchen_adventurer_cheesecake_brownie.jpg" />
              <p class="flex-caption">Adventurer Cheesecake Brownie</p>
  	    		</li>
  	    		<li>
  	    	    <img src="images/kitchen_adventurer_lemon.jpg" />
              <p class="flex-caption">Adventurer Lemon</p>
  	    		</li>
  	    		<li>
  	    	    <img src="images/kitchen_adventurer_donut.jpg" />
              <p class="flex-caption">Adventurer Donut</p>
  	    		</li>
  	    		<li>
  	    	    <img src="images/kitchen_adventurer_caramel.jpg" />
              <p class="flex-caption">Adventurer Caramel</p>
  	    		</li>
          </ul>
		*/
	}
	
	function onDrag() {
		var isDragging = false;
		var img = (jQuery)('#block-onepage-content .owl-carousel-portfolio .slides img');
		var deltaX, deltaY;
		
		img.mousedown(function(event) {
			isDragging = false;
			deltaX = event.offsetX;
			//deltaY = event.offsetY;
		})
		.mousemove(function(event) {
			isDragging = true;
		})
		.mouseup(function(event) {
			var wasDragging = isDragging;
			
			isDragging = false;
			deltaX -= event.offsetX;
			//deltaY -= event.offsetY;
			
			if (Math.abs(deltaX) > 20/* || Math.abs(deltaY) > 20*/) {
				if (deltaX < 0) {
					movePrev();
				} else {
					moveNext();
				}
				/*
				if (Math.abs(deltaX) > Math.abs(deltaY)) {
					if (deltaX < 0) {
						movePrev();
					} else {
						moveNext();
					}
				} else {
					if (deltaY < 0) {
						moveTop();
					} else {
						moveDown();
					}
				}
				*/				
			}
		});
	}
	
	function moveNext() {
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider({
			direction: "horizontal"
		});
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider("next");
	}
	
	function movePrev() {
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider({
			direction: "horizontal"
		});
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider("prev");
	}
	
	function moveTop() {
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider({
			direction: "vertical"
		});
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider("next");
	}
	
	function moveDown() {
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider({
			direction: "vertical"
		});
		(jQuery)('#block-onepage-content .owl-carousel-portfolio').flexslider("prev");
	}
	
	function getWholeElementHTML(element) {
		return (jQuery)('<div>').append((jQuery)(element).clone()).html();
	}
});