(function($) {
  Drupal.OnePage = Drupal.OnePage || {};
  Drupal.OnePage.currentRegion = null;
  Drupal.OnePage.menuItems = [];
  Drupal.OnePage.supportedScreens = [0.5, 479.5, 719.5, 959.5, 1049.5];
  Drupal.OnePage.currentActiveMenu = null;

  Drupal.behaviors.scrollMenuAction = {
    attach: function (context) {
      $(window).on('load', function() {
        $('.scrolling-point').css({top: "-" + $("#main-menu").height() + "px"});
        if ($('body.front').length) {
          $('#header ul.menu > li > a').each(function() {
            $(this).smoothScroll();
            var menu_item = $(this);
            var hr = $(this).attr('href');
            var parts = hr.split('#');
            var id = parts[1];
            if (menu_item.length) {
              Drupal.OnePage.menuItems.push(menu_item);
              menu_item.attr('data-id', id);
              menu_item.attr('data-link-type', 'scroll');
              // menu_item.attr('data-hash', Drupal.settings.basePath + "#" + id);
              // menu_item.attr('href', Drupal.settings.basePath + "#" + id);
            }
          });
          Drupal.OnePage.calculateScroll();
          Drupal.OnePage.checkActiveItem();
          $(window).scroll(function() {
            Drupal.OnePage.checkActiveItem();
          });
        }
      });
      $(window).resize(function() {
        Drupal.OnePage.calculateScroll();
      });
    }
  };

  Drupal.OnePage.checkActiveItem = function () {
    var top = $(window).scrollTop();
    var bottom = top + $(window).height();
    var selected_item = -1;
    var current_delta = 0;
    var min_delta = 10000;
    for(i = 0; i < Drupal.OnePage.menuItems.length; i ++) {
      var menu_item = Drupal.OnePage.menuItems[i];
      var i_top = $(menu_item).attr('data-top');
      var i_bottom = $(menu_item).attr('data-bottom');
      current_delta = Math.abs(top - i_top + bottom - i_bottom);
      if(current_delta < min_delta) {
        min_delta = current_delta;
        selected_item = i;
      }
    }
    if (selected_item !== Drupal.OnePage.currentRegion) {
      for (j = 0; j < Drupal.OnePage.menuItems.length; j ++) {
        if (j !== selected_item) {
          $(Drupal.OnePage.menuItems[j]).removeClass('current');
        }
      }
      $(Drupal.OnePage.menuItems[selected_item]).addClass('current');
    }    
  }

  Drupal.OnePage.calculateScroll = function () {
    for(var x in Drupal.OnePage.menuItems) {
      var menu_item = Drupal.OnePage.menuItems[x];
      var id = $(menu_item).attr('data-id');
      var element = $("#" + id);
      if(element.length) {
        var offset = $(element).offset();
        $(menu_item).attr('data-top', offset.top);
        var next_x = parseInt(x) + 1;
        
        if(Drupal.OnePage.menuItems.length > next_x) {
            var next_item = Drupal.OnePage.menuItems[next_x];
            var next_id = $(next_item).attr('data-id');
            var next_element = $("#" + next_id);
            if(next_element.length) {
                $(menu_item).attr('data-bottom', $(next_element).offset().top);
            }
        }
        else {
            $(menu_item).attr('data-bottom', $('body').height());
        }
      }
      Drupal.OnePage.currentActiveMenu = id;
    }
  };

})(jQuery);
